{*******************************************************}
{                                                       }
{       RichViewActions                                 }
{       Demo project.                                   }
{       You can use it as a basis for your              }
{       applications.                                   }
{                                                       }
{       Copyright (c) Sergey Tkachenko                  }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}

unit Unit3Unicode;

interface

{$I RV_Defs.inc}          // contains defines about Delphi compiler versions

uses
  Windows, Messages, SysUtils,
  Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,
  ActnList, StdActns, ImgList,
  Menus, ShellApi, Printers, ToolWin, RVUni,
  RVScroll, RichView, RVEdit,
  RVStyle, PtblRV, CRVFData, RVTable, RVItem, CRVData, RVFuncs, IMouse,
  RichViewActions, RVALocRuler, RVFontCombos, RVALocalize, RVRulerBase, RVRuler,
  GifImg, RVGifAnimate2007,
  PngImage, RVTypes, RVStyleFuncs, RVGrHandler,
  dmActionsImages1, dmActionsImages2;

type
  TForm3 = class(TForm)
    RVStyle1: TRVStyle;
    StatusBar1: TStatusBar;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton11: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton13: TToolButton;
    ToolButton22: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolBar2: TToolBar;
    ToolButton41: TToolButton;
    ToolButton42: TToolButton;
    ToolButton43: TToolButton;
    ToolButton44: TToolButton;
    ToolButton49: TToolButton;
    ToolButton50: TToolButton;
    ToolButton51: TToolButton;
    ToolButton53: TToolButton;
    ToolButton54: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolBar3: TToolBar;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton12: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton23: TToolButton;
    ToolButton24: TToolButton;
    ToolButton25: TToolButton;
    ToolButton26: TToolButton;
    ToolButton28: TToolButton;
    ToolButton8: TToolButton;
    ToolButton27: TToolButton;
    ToolButton29: TToolButton;
    ToolButton30: TToolButton;
    ToolButton31: TToolButton;
    ToolButton32: TToolButton;
    ToolButton33: TToolButton;
    ToolButton34: TToolButton;
    ToolButton35: TToolButton;
    ToolButton36: TToolButton;
    ToolButton37: TToolButton;
    ToolButton38: TToolButton;
    ToolButton39: TToolButton;
    ToolButton40: TToolButton;
    ToolButton45: TToolButton;
    RVAControlPanel1: TRVAControlPanel;
    ToolButton46: TToolButton;
    ToolButton47: TToolButton;
    ToolBar4: TToolBar;
    ToolButton48: TToolButton;
    ToolButton52: TToolButton;
    ToolButton55: TToolButton;
    ToolButton56: TToolButton;
    ToolButton58: TToolButton;
    ToolButton59: TToolButton;
    ToolButton57: TToolButton;
    ToolButton60: TToolButton;
    ToolButton61: TToolButton;
    ToolBar5: TToolBar;
    cmbFont: TRVFontComboBox;
    RVAPopupMenu1: TRVAPopupMenu;
    RVPrint1: TRVPrint;
    ColorDialog1: TColorDialog;
    btnLanguage: TButton;
    cmbFontSize: TRVFontSizeComboBox;
    ToolButton62: TToolButton;
    ToolButton63: TToolButton;
    pmFakeDropDown: TPopupMenu;
    ToolButton64: TToolButton;
    ToolButton65: TToolButton;
    MainMenu1: TMainMenu;
    mitFile: TMenuItem;
    New1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Export1: TMenuItem;
    N1: TMenuItem;
    PageSetup1: TMenuItem;
    PrintPreview1: TMenuItem;
    Print1: TMenuItem;
    N3: TMenuItem;
    mitExit: TMenuItem;
    mitEdit: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N4: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    n2: TMenuItem;
    rvActionPasteAsText11: TMenuItem;
    PasteSpecial1: TMenuItem;
    N5: TMenuItem;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    Replace1: TMenuItem;
    N26: TMenuItem;
    CharacterCase1: TMenuItem;
    N20: TMenuItem;
    InsertPageBreak1: TMenuItem;
    RemovePageBreak1: TMenuItem;
    N15: TMenuItem;
    SelectAll1: TMenuItem;
    mitFont: TMenuItem;
    Font1: TMenuItem;
    N7: TMenuItem;
    mitFontStyle: TMenuItem;
    Bold1: TMenuItem;
    Italic1: TMenuItem;
    Underline1: TMenuItem;
    Strikeout1: TMenuItem;
    N14: TMenuItem;
    AllCapitals1: TMenuItem;
    Overline1: TMenuItem;
    N27: TMenuItem;
    rvActionSubscript11: TMenuItem;
    rvActionSuperscript11: TMenuItem;
    mitFontSize: TMenuItem;
    ShrinkFont1: TMenuItem;
    GrowFont1: TMenuItem;
    N13: TMenuItem;
    ShrinkFontByOnePoint1: TMenuItem;
    GrowFontByOnePoint1: TMenuItem;
    extColor1: TMenuItem;
    extBackgroundColor1: TMenuItem;
    mitPara: TMenuItem;
    rvActionParagraph11: TMenuItem;
    ParagraphBorders1: TMenuItem;
    N18: TMenuItem;
    AlignLeft1: TMenuItem;
    AlignCenter1: TMenuItem;
    AlignRight1: TMenuItem;
    Justify1: TMenuItem;
    N25: TMenuItem;
    BulletsandNumbering1: TMenuItem;
    Bullets1: TMenuItem;
    Numbering1: TMenuItem;
    N16: TMenuItem;
    Leftjustify1: TMenuItem;
    N6: TMenuItem;
    DecreaseIndent1: TMenuItem;
    IncreaseIndent1: TMenuItem;
    N17: TMenuItem;
    SingleLineSpacing1: TMenuItem;
    N15LineSpacing1: TMenuItem;
    DoubleLineSpacing1: TMenuItem;
    N28: TMenuItem;
    mitTextFlow: TMenuItem;
    ClearTextFlowatLeftSide1: TMenuItem;
    ClearTextFlowatRightSide1: TMenuItem;
    ClearTextFlowatBothSides1: TMenuItem;
    NormalTextFlow1: TMenuItem;
    N19: TMenuItem;
    ParagraphBackgroundColor1: TMenuItem;
    mitFormat: TMenuItem;
    Background1: TMenuItem;
    BackgroundColor1: TMenuItem;
    N22: TMenuItem;
    FillColor1: TMenuItem;
    N29: TMenuItem;
    RemoveHyperlinks1: TMenuItem;
    N30: TMenuItem;
    Properties1: TMenuItem;
    ObjectPosition1: TMenuItem;
    mitInsert: TMenuItem;
    File1: TMenuItem;
    Picture1: TMenuItem;
    HorizontalLine1: TMenuItem;
    HypertextLink1: TMenuItem;
    InsertSymbol1: TMenuItem;
    mitTable: TMenuItem;
    InsertTable1: TMenuItem;
    N9: TMenuItem;
    InsertColumnLeft1: TMenuItem;
    InsertColumnRight1: TMenuItem;
    N8: TMenuItem;
    InsertRowAbove1: TMenuItem;
    InsertRowBelow1: TMenuItem;
    N10: TMenuItem;
    DeleteRows1: TMenuItem;
    rvActionTableDeleteCols11: TMenuItem;
    DeleteTable1: TMenuItem;
    N12: TMenuItem;
    mitTableSelect: TMenuItem;
    SelectTable1: TMenuItem;
    SelectColumns1: TMenuItem;
    SelectRows1: TMenuItem;
    SelectCell1: TMenuItem;
    N21: TMenuItem;
    mitTableAlignCellContents: TMenuItem;
    AlignCellToTheTop1: TMenuItem;
    AlignCellToTheMiddle1: TMenuItem;
    AlignCellToTheBottom1: TMenuItem;
    DefaultCellVerticalAlignment1: TMenuItem;
    mitTableCellBorders: TMenuItem;
    LeftBorder1: TMenuItem;
    rvActionTableCellTopBorder11: TMenuItem;
    rvActionTableCellRightBorder11: TMenuItem;
    rvActionTableCellBottomBorder11: TMenuItem;
    rvActionTableCellAllBorders11: TMenuItem;
    rvActionTableCellNoBorders11: TMenuItem;
    N11: TMenuItem;
    SplitCells1: TMenuItem;
    MergeCells1: TMenuItem;
    N24: TMenuItem;
    ShowGridLines1: TMenuItem;
    N23: TMenuItem;
    ableProperties1: TMenuItem;
    mitHelp: TMenuItem;
    mitHelpTOC: TMenuItem;
    tbUnits: TToolBar;
    cmbUnits: TComboBox;
    mitTableCellRotation: TMenuItem;
    NoCellRotation1: TMenuItem;
    RotateCellby90Degrees1: TMenuItem;
    RotateCellby180Degrees1: TMenuItem;
    RotateCellby270Degrees1: TMenuItem;
    btnSkin: TButton;
    ConverttoText1: TMenuItem;
    Sort1: TMenuItem;
    SplitTable1: TMenuItem;
    ToolButton68: TToolButton;
    ToolButton69: TToolButton;
    ToolButton70: TToolButton;
    ProgressBar1: TProgressBar;
    Styles1: TMenuItem;
    AddStyle1: TMenuItem;
    ClearFormat1: TMenuItem;
    ClearTextFormat1: TMenuItem;
    InspectStyles1: TMenuItem;
    N31: TMenuItem;
    cmbStyles: TRVStyleTemplateComboBox;
    N32: TMenuItem;
    InsertFootnote1: TMenuItem;
    InsertEndnote1: TMenuItem;
    EditNote1: TMenuItem;
    InsertSidenote1: TMenuItem;
    Number1: TMenuItem;
    extBox1: TMenuItem;
    InsertCaption1: TMenuItem;
    ToolButton71: TToolButton;
    PageNumber1: TMenuItem;
    ActionList1: TActionList;
    rvActionNew1: TrvActionNew;
    rvActionOpen1: TrvActionOpen;
    rvActionSave1: TrvActionSave;
    rvActionSaveAs1: TrvActionSaveAs;
    rvActionExport1: TrvActionExport;
    rvActionPrintPreview1: TrvActionPrintPreview;
    rvActionPrint1: TrvActionPrint;
    rvActionQuickPrint1: TrvActionQuickPrint;
    rvActionCut1: TrvActionCut;
    rvActionCopy1: TrvActionCopy;
    rvActionPaste1: TrvActionPaste;
    rvActionParagraph1: TrvActionParagraph;
    rvActionIndentInc1: TrvActionIndentInc;
    rvActionIndentDec1: TrvActionIndentDec;
    rvActionPasteAsText1: TrvActionPasteAsText;
    rvActionPasteSpecial1: TrvActionPasteSpecial;
    rvActionSelectAll1: TrvActionSelectAll;
    rvActionUndo1: TrvActionUndo;
    rvActionRedo1: TrvActionRedo;
    rvActionFonts1: TrvActionFonts;
    rvActionFontEx1: TrvActionFontEx;
    rvActionFontBold1: TrvActionFontBold;
    rvActionFontItalic1: TrvActionFontItalic;
    rvActionFontUnderline1: TrvActionFontUnderline;
    rvActionFontStrikeout1: TrvActionFontStrikeout;
    rvActionFontGrow1: TrvActionFontGrow;
    rvActionFontShrink1: TrvActionFontShrink;
    rvActionFontGrowOnePoint1: TrvActionFontGrowOnePoint;
    rvActionFontShrinkOnePoint1: TrvActionFontShrinkOnePoint;
    rvActionWordWrap1: TrvActionWordWrap;
    rvActionAlignLeft1: TrvActionAlignLeft;
    rvActionAlignRight1: TrvActionAlignRight;
    rvActionAlignCenter: TrvActionAlignCenter;
    rvActionAlignJustify1: TrvActionAlignJustify;
    rvActionInsertTable1: TrvActionInsertTable;
    rvActionTableInsertRowsAbove1: TrvActionTableInsertRowsAbove;
    rvActionTableInsertRowsBelow1: TrvActionTableInsertRowsBelow;
    rvActionTableInsertColLeft1: TrvActionTableInsertColLeft;
    rvActionTableInsertColRight1: TrvActionTableInsertColRight;
    rvActionTableDeleteRows1: TrvActionTableDeleteRows;
    rvActionTableDeleteCols1: TrvActionTableDeleteCols;
    rvActionTableDeleteTable1: TrvActionTableDeleteTable;
    rvActionTableMergeCells1: TrvActionTableMergeCells;
    rvActionTableSplitCells1: TrvActionTableSplitCells;
    rvActionTableSelectTable1: TrvActionTableSelectTable;
    rvActionTableSelectRows1: TrvActionTableSelectRows;
    rvActionTableSelectCols1: TrvActionTableSelectCols;
    rvActionTableSelectCell1: TrvActionTableSelectCell;
    rvActionFontAllCaps1: TrvActionFontAllCaps;
    rvActionFontOverline1: TrvActionFontOverline;
    rvActionFind1: TrvActionFind;
    rvActionFindNext1: TrvActionFindNext;
    rvActionReplace1: TrvActionReplace;
    rvActionFontColor1: TrvActionFontColor;
    rvActionFontBackColor1: TrvActionFontBackColor;
    rvActionParaColor1: TrvActionParaColor;
    rvActionColor1: TrvActionColor;
    rvActionFillColor1: TrvActionFillColor;
    rvActionInsertFile1: TrvActionInsertFile;
    rvActionInsertPicture1: TrvActionInsertPicture;
    rvActionLineSpacing1001: TrvActionLineSpacing100;
    rvActionLineSpacing1501: TrvActionLineSpacing150;
    rvActionLineSpacing2001: TrvActionLineSpacing200;
    rvActionInsertPageBreak1: TrvActionInsertPageBreak;
    rvActionRemovePageBreak1: TrvActionRemovePageBreak;
    rvActionTableCellVAlignTop1: TrvActionTableCellVAlignTop;
    rvActionTableCellVAlignMiddle1: TrvActionTableCellVAlignMiddle;
    rvActionTableCellVAlignBottom1: TrvActionTableCellVAlignBottom;
    rvActionTableCellVAlignDefault1: TrvActionTableCellVAlignDefault;
    rvActionParaBorder1: TrvActionParaBorder;
    rvActionItemProperties1: TrvActionItemProperties;
    rvActionInsertHLine1: TrvActionInsertHLine;
    rvActionInsertHyperlink1: TrvActionInsertHyperlink;
    rvActionTableProperties1: TrvActionTableProperties;
    rvActionTableGrid1: TrvActionTableGrid;
    rvActionParaList1: TrvActionParaList;
    rvActionInsertSymbol1: TrvActionInsertSymbol;
    rvActionTableCellLeftBorder1: TrvActionTableCellLeftBorder;
    rvActionTableCellRightBorder1: TrvActionTableCellRightBorder;
    rvActionTableCellTopBorder1: TrvActionTableCellTopBorder;
    rvActionTableCellBottomBorder1: TrvActionTableCellBottomBorder;
    rvActionTableCellAllBorders1: TrvActionTableCellAllBorders;
    rvActionTableCellNoBorders1: TrvActionTableCellNoBorders;
    rvActionParaBullets1: TrvActionParaBullets;
    rvActionParaNumbering1: TrvActionParaNumbering;
    rvActionBackground1: TrvActionBackground;
    rvActionPageSetup1: TrvActionPageSetup;
    rvActionTextRTL1: TrvActionTextRTL;
    rvActionTextLTR1: TrvActionTextLTR;
    rvActionParaRTL1: TrvActionParaRTL;
    rvActionParaLTR1: TrvActionParaLTR;
    rvActionCharCase1: TrvActionCharCase;
    rvActionShowSpecialCharacters1: TrvActionShowSpecialCharacters;
    rvActionSubscript1: TrvActionSubscript;
    rvActionSuperscript1: TrvActionSuperscript;
    rvActionClearLeft1: TrvActionClearLeft;
    rvActionClearRight1: TrvActionClearRight;
    rvActionClearBoth1: TrvActionClearBoth;
    rvActionClearNone1: TrvActionClearNone;
    rvActionVAlign1: TrvActionVAlign;
    rvActionRemoveHyperlinks1: TrvActionRemoveHyperlinks;
    rvActionHide1: TrvActionHide;
    rvActionTableCellRotationNone1: TrvActionTableCellRotationNone;
    rvActionTableCellRotation901: TrvActionTableCellRotation90;
    rvActionTableCellRotation1801: TrvActionTableCellRotation180;
    rvActionTableCellRotation2701: TrvActionTableCellRotation270;
    rvActionTableSplit1: TrvActionTableSplit;
    rvActionTableToText1: TrvActionTableToText;
    rvActionTableSort1: TrvActionTableSort;
    rvActionStyleTemplates1: TrvActionStyleTemplates;
    rvActionAddStyleTemplate1: TrvActionAddStyleTemplate;
    rvActionClearFormat1: TrvActionClearFormat;
    rvActionClearTextFormat1: TrvActionClearTextFormat;
    rvActionStyleInspector1: TrvActionStyleInspector;
    rvActionInsertFootnote1: TrvActionInsertFootnote;
    rvActionInsertEndnote1: TrvActionInsertEndnote;
    rvActionInsertSidenote1: TrvActionInsertSidenote;
    rvActionInsertTextBox1: TrvActionInsertTextBox;
    rvActionEditNote1: TrvActionEditNote;
    rvActionInsertNumber1: TrvActionInsertNumber;
    rvActionInsertCaption1: TrvActionInsertCaption;
    rvActionInsertPageNumber1: TrvActionInsertPageNumber;
    mitTools: TMenuItem;
    mitImages1: TMenuItem;
    mitImages2: TMenuItem;
    N33: TMenuItem;
    mitLanguage: TMenuItem;
    mitSkin: TMenuItem;
    ToolButton72: TToolButton;
    rvActionAlignDistribute1: TrvActionAlignDistribute;
    Distribute1: TMenuItem;
    rvActionInsertPageCount1: TrvActionInsertPageCount;
    PageCount1: TMenuItem;
    rvActionTableCellVerticalFonts1: TrvActionTableCellVerticalFonts;
    rvActionTableCellReverseLineOrder1: TrvActionTableCellReverseLineOrder;
    N35: TMenuItem;
    rvActionTableCellVerticalFonts11: TMenuItem;
    rvActionTableCellReverseLineOrder11: TMenuItem;
    rvActionBookmarks1: TrvActionBookmarks;
    Bookmark1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    RVRuler1: TRVRuler;
    RichViewEdit1: TRichViewEdit;
    ilDocTypes: TImageList;
    mitClose: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mitExitClick(Sender: TObject);
    procedure RichViewEdit1Jump(Sender: TObject; id: Integer);
    procedure RichViewEdit1ReadHyperlink(Sender: TCustomRichView;
      const Target, Extras: TRVUnicodeString; DocFormat: TRVLoadFormat;
      var StyleNo: Integer; var ItemTag: TRVTag;
      var ItemName: TRVUnicodeString);
    procedure btnLanguageClick(Sender: TObject);
    procedure RVAControlPanel1MarginsChanged(Sender: TrvAction;
      Edit: TCustomRichViewEdit);
    procedure RVAControlPanel1Download(Sender: TrvAction;
      const Source: TRVUnicodeString);
    procedure pmFakeDropDownPopup(Sender: TObject);
    procedure RichViewEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure mitHelpTOCClick(Sender: TObject);
    procedure RichViewEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmbUnitsClick(Sender: TObject);
    procedure btnSkinClick(Sender: TObject);
    procedure RichViewEdit1Progress(Sender: TCustomRichView;
      Operation: TRVLongOperation; Stage: TRVProgressStage; PercentDone: Byte);
    procedure RVPrint1SendingToPrinter(Sender: TCustomRichView;
      PageCompleted: Integer; Step: TRVPrintingStep);
    procedure mitImages1Click(Sender: TObject);
    procedure mitImages2Click(Sender: TObject);
    procedure RichViewEdit1Change(Sender: TObject);
    procedure rvActionNew1Execute(Sender: TObject);
    procedure rvActionOpen1Execute(Sender: TObject);
    procedure mitCloseClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure rvActionSave1DocumentFileChange(Sender: TObject;
      Editor: TCustomRichViewEdit; const FileName: TRVUnicodeString;
      FileFormat: TrvFileSaveFilter; IsNew: Boolean);
    procedure PageControl1Changing(Sender: TObject; var AllowChange: Boolean);
  private
    { Private declarations }
    Editors : array of TCustomRichViewEdit;
    ActiveEditor: TCustomRichViewEdit;
    procedure ColorPickerShow(Sender: TObject);
    procedure ColorPickerHide(Sender: TObject);
    procedure rvActionEditNoteFormCreate(Sender: TrvAction; Form: TForm);
    procedure rvActionEditNoteShowing(Sender: TrvAction; Form: TForm);
    procedure rvActionEditNoteHide(Sender: TObject);
    procedure NoteEditorEnter(Sender: TObject);
    procedure NoteEditorExit(Sender: TObject);
    procedure UpdateLinkedControls;
    procedure Localize;
    procedure ChangeImages(ilNormal, ilDisabled: TCustomImageList);
    function GetIconIndex(IsNew: Boolean; FileFormat: TrvFileSaveFilter;
      Modified: Boolean): Integer;
    function GetIndexOfEditor(rve: TCustomRichViewEdit): Integer;
    procedure AddEditor;
    function GetActiveDocInfo: TrvaDocumentInfo;
    function GetDocInfo(rve: TCustomRichViewEdit): TrvaDocumentInfo;
    function GetRuler(rve: TCustomRichViewEdit): TRVRuler;
    procedure RemoveEditor(Index: Integer);
    procedure UpdateIcon(Editor: TCustomRichViewEdit);
    function CloseActiveEditor: Boolean;
    procedure ChangeUnits;
    procedure SetForceFieldHighlight(Value: Boolean);
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

function GetFullFileName(const FileName: String): String;
begin
  Result := ExtractFilePath(Application.ExeName) + FileName;
  if FileExists(Result) then
    exit;
  Result := ExtractFilePath(Application.ExeName) + '..\' + FileName;
  if FileExists(Result) then
    exit;
  Result := ExtractFilePath(Application.ExeName) + '..\..\' + FileName;
  if FileExists(Result) then
    exit;
  Result := '';
end;

procedure TForm3.FormCreate(Sender: TObject);
var
  FileName: String;
  rvs: TRVStyle;
begin
   // changing RVStyle1.Owner to RichViewEdit1
  rvs := RVStyle1;
  RemoveComponent(rvs);
  RichViewEdit1.InsertComponent(rvs);
  RichViewEdit1.Style := rvs;
  // initializing Editors[] and ActiveEditor
  SetLength(Editors, 1);
  Editors[0] := RichViewEdit1;
  ActiveEditor := RichViewEdit1;
  RVAControlPanel1.DefaultControl := RichViewEdit1;
  PageControl1.ActivePageIndex := 0;


  cmbFont.Font.Name := RVAControlPanel1.DialogFontName;
  cmbFontSize.Font.Name := RVAControlPanel1.DialogFontName;
  cmbUnits.Font.Name := RVAControlPanel1.DialogFontName;
  cmbStyles.Font.Name := RVAControlPanel1.DialogFontName;

  // Almost all these assignments could be done at design time in the Object Inspector
  // But in this demo we do not want to modify rvActionsResource
  // (and we recommend to use a copy of it in your applications)

  rvActionSave1.OnDocumentFileChange := rvActionSave1DocumentFileChange;

  // initializing TrvActionEditNote action
  rvActionEditNote1.OnFormCreate := rvActionEditNoteFormCreate;
  rvActionEditNote1.OnShowing := rvActionEditNoteShowing;
  rvActionEditNote1.OnHide := rvActionEditNoteHide;

  // linking combo boxes and style inspector to ActiveEditor
  UpdateLinkedControls;

  // Code for making color-picking buttons stay pressed while a
  // color-picker window is visible.
  rvActionColor1.OnShowColorPicker := ColorPickerShow;
  rvActionColor1.OnHideColorPicker := ColorPickerHide;
  rvActionParaColor1.OnShowColorPicker := ColorPickerShow;
  rvActionParaColor1.OnHideColorPicker := ColorPickerHide;
  rvActionFontColor1.OnShowColorPicker := ColorPickerShow;
  rvActionFontColor1.OnHideColorPicker := ColorPickerHide;
  rvActionFontBackColor1.OnShowColorPicker := ColorPickerShow;
  rvActionFontBackColor1.OnHideColorPicker := ColorPickerHide;

  cmbUnits.ItemIndex := ord(RVAControlPanel1.UnitsDisplay);

  Localize;
  mitImages1Click(nil);

  // The ruler initialization might set Modify flag, clearing it
  ActiveEditor.Modified := False;
  // Loading initial file via ActionOpen
  FileName := GetFullFileName('readme.rvf');
  if FileName <> '' then
    rvActionOpen1.LoadFile(ActiveEditor, FileName, ffiRVF)
  else
    rvActionNew1.ExecuteTarget(ActiveEditor);
  UpdateIcon(ActiveEditor);
end;

{--------------- Working with color-picking buttons ---------------------------}

// Code for making color-picking buttons pressed while
// a color-picker window is visible.
procedure TForm3.ColorPickerShow(Sender: TObject);
begin
  if (Sender as TAction).ActionComponent is TToolButton then
    TToolButton(TAction(Sender).ActionComponent).Down := True;
end;

procedure TForm3.ColorPickerHide(Sender: TObject);
begin
  if (Sender as TAction).ActionComponent is TToolButton then
    TToolButton(TAction(Sender).ActionComponent).Down := False;
end;

{-------------- Set of events for processing hypertext jumps ------------------}

// Hyperlink click
procedure TForm3.RichViewEdit1Jump(Sender: TObject; id: Integer);
begin
  rvActionInsertHyperlink1.GoToLink(Sender as TCustomRichViewEdit, id);
end;

// Importing hyperlink from RTF, HTML, or accepting from drag&drop
procedure TForm3.RichViewEdit1ReadHyperlink(Sender: TCustomRichView;
  const Target, Extras: TRVUnicodeString; DocFormat: TRVLoadFormat;
  var StyleNo: Integer;
  var ItemTag: TRVTag; var ItemName: TRVUnicodeString);
begin
  if DocFormat = rvlfURL then
    StyleNo := rvActionInsertHyperlink1.GetHyperlinkStyleNo(Sender as TCustomRichViewEdit);
  ItemTag := rvActionInsertHyperlink1.EncodeTarget(Target);
end;

// URL detection on typing
procedure TForm3.RichViewEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_RETURN) then
  begin
    rvActionInsertHyperlink1.DetectURL(Sender as TCustomRichViewEdit);
    rvActionInsertHyperlink1.TerminateHyperlink(Sender as TCustomRichViewEdit);
  end;
end;

procedure TForm3.RichViewEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if CharInSet(Key, [#9, ' ', ',', ';']) then
  begin
    rvActionInsertHyperlink1.DetectURL(Sender as TCustomRichViewEdit);
    rvActionInsertHyperlink1.TerminateHyperlink(Sender as TCustomRichViewEdit);
  end;
end;

{----------------------- Insert table popup      -----------------------------}
{ We use a trick: insert-table button has style tbsDropDown and assigned
  DropDownMenu (pmFakeDropDown). This menu is empty, but shows table size
 popup instead of itself }
procedure TForm3.pmFakeDropDownPopup(Sender: TObject);
begin
  rvActionInsertTable1.ShowTableSizeDialog(ActiveEditor, ToolButton12);
end;

{---------------------------- Ruler ------------------------------------}

procedure TForm3.RVAControlPanel1MarginsChanged(Sender: TrvAction;
  Edit: TCustomRichViewEdit);
begin
  RVRuler1.UpdateRulerMargins;
end;

{---------------------------- Localization ------------------------------------}

procedure TForm3.btnLanguageClick(Sender: TObject);
begin
  if RVA_ChooseLanguage then
    Localize;
end;

procedure TForm3.Localize;
var
  i: Integer;
begin
  // Fonts
  Font.Charset := RVA_GetCharset;
  StatusBar1.Font.Charset := RVA_GetCharset;
  Screen.HintFont.Charset := RVA_GetCharset;
  Screen.MenuFont.Charset := RVA_GetCharset;
  // Localizing all actions on this form
  RVA_LocalizeForm(Self);
  // Localizing ruler
  RVALocalizeRuler(RVRuler1);
  // Units
  i := cmbUnits.ItemIndex;
  RVA_TranslateUnits(cmbUnits.Items);
  cmbUnits.ItemIndex := i;
  for i := 0 to CoolBar1.Bands.Count - 1 do
    if CoolBar1.Bands[i].Control = tbUnits then
      CoolBar1.Bands[i].Text := RVA_GetS(rvam_lbl_Units);
  // Styles
  rvActionStyleInspector1.UpdateInfo;
  cmbStyles.Localize;
  // Localizing menus
  mitFile.Caption := RVA_GetS(rvam_menu_File);
  mitEdit.Caption := RVA_GetS(rvam_menu_Edit);
  mitFont.Caption := RVA_GetS(rvam_menu_Font);
  mitPara.Caption := RVA_GetS(rvam_menu_Para);
  mitFormat.Caption := RVA_GetS(rvam_menu_Format);
  mitInsert.Caption := RVA_GetS(rvam_menu_Insert);
  mitTable.Caption := RVA_GetS(rvam_menu_Table);
  mitTools.Caption := RVA_GetS(rvam_menu_Tools);
  mitExit.Caption := RVA_GetS(rvam_menu_Exit);
  mitHelp.Caption := RVA_GetS(rvam_menu_Help);
  mitHelpTOC.Caption := RVA_GetS(rvam_menu_Help);

  mitFontSize.Caption := RVA_GetS(rvam_menu_FontSize);
  mitFontStyle.Caption := RVA_GetS(rvam_menu_FontStyle);
  mitTextFlow.Caption := RVA_GetS(rvam_menu_TextFlow);
  mitTableSelect.Caption := RVA_GetS(rvam_menu_TableSelect);
  mitTableCellBorders.Caption := RVA_GetS(rvam_menu_TableCellBorders);
  mitTableAlignCellContents.Caption := RVA_GetS(rvam_menu_TableCellAlign);
  mitTableCellRotation.Caption := RVA_GetS(rvam_menu_TableCellRotation);
end;

{-------------------- Progress messages ---------------------------------------}
// Downloading
procedure TForm3.RVAControlPanel1Download(Sender: TrvAction;
  const Source: TRVUnicodeString);
begin
  if Source = '' then
    Application.Hint := ''
  else
    Application.Hint := Format(RVA_GetS(rvam_msg_Downloading), [Source]);
end;

// Reading/writing
procedure TForm3.RichViewEdit1Progress(Sender: TCustomRichView;
  Operation: TRVLongOperation; Stage: TRVProgressStage; PercentDone: Byte);
begin
  case Stage of
    rvpstgStarting:
      begin
        ProgressBar1.Left := btnSkin.Left - ProgressBar1.Width - 8;
        ProgressBar1.Top := btnSkin.Top +
          (btnSkin.Height - ProgressBar1.Height) div 2;
        ProgressBar1.Position := 0;
        ProgressBar1.Visible := True;
        Application.Hint := RVA_GetProgressMessage(Operation);
      end;
    rvpstgRunning:
      begin
        ProgressBar1.Position := PercentDone;
        ProgressBar1.Update;
      end;
    rvpstgEnding:
      begin
        ProgressBar1.Position := 100;
        ProgressBar1.Update;
        Application.Hint := '';
        ProgressBar1.Visible := False;
      end;
  end;
end;

// Printing
procedure TForm3.RVPrint1SendingToPrinter(Sender: TCustomRichView;
  PageCompleted: Integer; Step: TRVPrintingStep);
begin
  Application.Hint := RVA_GetPrintingMessage(PageCompleted, Step);
end;

{-------------------------------- Misc. ---------------------------------------}

procedure TForm3.mitHelpTOCClick(Sender: TObject);
var
  HelpFileName: TRVUnicodeString;
begin
  HelpFileName := GetFullFileName('Help\RichViewActions.chm');
  if HelpFileName <> '' then
    RvHtmlHelp(HelpFileName);
end;

procedure TForm3.mitImages1Click(Sender: TObject);
begin
  ChangeImages(rvActionsImages1.ilNormal, rvActionsImages1.ilDisabled);
  mitImages1.Checked := True;
  mitImages2.Checked := False;
end;

procedure TForm3.mitImages2Click(Sender: TObject);
begin
  ChangeImages(rvActionsImages2.ilNormal, rvActionsImages2.ilDisabled);
  mitImages1.Checked := False;
  mitImages2.Checked := True;
end;

procedure TForm3.ChangeImages(ilNormal, ilDisabled: TCustomImageList);
var
  i: Integer;
begin
  for i := 0 to ComponentCount - 1 do
    if Components[i] is TToolBar then
    begin
      TToolBar(Components[i]).Images := ilNormal;
      TToolBar(Components[i]).DisabledImages := ilDisabled;
    end;
  MainMenu1.Images := ilNormal;
  RVAPopupMenu1.Images := ilNormal;
  rvActionStyleTemplates1.Images := ilNormal;
  rvActionStyleInspector1.Images := ilNormal;
  rvActionStyleInspector1.UpdateInfo;
  cmbStyles.Images := ilNormal;
end;

procedure TForm3.cmbUnitsClick(Sender: TObject);
begin
  // --- 1. Units displayed to the user
  // units for displaying in dialogs
  RVAControlPanel1.UnitsDisplay := TRVUnits(cmbUnits.ItemIndex);
  // units for displaying in the ruler
  RVRuler1.UnitsDisplay := TRulerUnits(cmbUnits.ItemIndex);
  // units for page setup dialog
  if RVAControlPanel1.UnitsDisplay in [rvuPixels, rvuCentimeters, rvuMillimeters]
  then
    rvActionPageSetup1.MarginsUnits := rvpmuMillimeters
  else
    rvActionPageSetup1.MarginsUnits := rvpmuInches;
  // --- 2. units for internal measurement
  // units of measurement for RichViewActions
  if RVAControlPanel1.UnitsDisplay = rvuPixels then
  begin
    RVA_ConvertToPixels(Self, RVStyle1);
    RVAControlPanel1.UnitsProgram := rvstuPixels;
  end
  else
  begin
    RVA_ConvertToEMU(Self, RVStyle1);
    RVAControlPanel1.UnitsProgram := rvstuEMU;
  end;
  // units of measurement for the current document
  if ActiveEditor.Style.Units <> RVAControlPanel1.UnitsProgram then
    ChangeUnits;
  ActiveEditor.SetFocus;
end;

{------------------------------- Notes ----------------------------------------}
procedure TForm3.rvActionEditNoteFormCreate(Sender: TrvAction; Form: TForm);
begin
  rvActionEditNote1.SubDocEditor.OnEnter := NoteEditorEnter;
  rvActionEditNote1.SubDocEditor.OnExit := NoteEditorExit;
  rvActionEditNote1.SubDocEditor.PopupMenu := RVAPopupMenu1;
  Form.Align := alBottom;
  Form.Height := 100;
  Form.Parent := Self;
end;

procedure TForm3.rvActionEditNoteShowing(Sender: TrvAction; Form: TForm);
begin
  SetForceFieldHighlight(True);
end;

procedure TForm3.rvActionEditNoteHide(Sender: TObject);
begin
  SetForceFieldHighlight(False);
  if ActiveEditor.CanFocus then
    ActiveEditor.SetFocus;
end;

procedure TForm3.NoteEditorEnter(Sender: TObject);
begin
  RVAControlPanel1.DefaultControl := rvActionEditNote1.SubDocEditor;
  UpdateLinkedControls;
end;

procedure TForm3.NoteEditorExit(Sender: TObject);
begin
  RVAControlPanel1.DefaultControl := ActiveEditor;
  UpdateLinkedControls;
end;

procedure TForm3.UpdateLinkedControls;
begin
  rvActionStyleInspector1.Control := RVAControlPanel1.DefaultControl;
  cmbFont.Editor := RVAControlPanel1.DefaultControl;
  cmbFontSize.Editor := RVAControlPanel1.DefaultControl;
  cmbStyles.Editor := RVAControlPanel1.DefaultControl;

  rvActionEditNote1.Control := ActiveEditor;
end;

{----------------------- UI Styles (Delphi XE2+ -------------------------------}
procedure TForm3.btnSkinClick(Sender: TObject);
begin
  RVA_ChooseStyle;
end;

{-------------------------- Tabbed User Interface -----------------------------}
{
  Main variables:
  Editors[] - array of opened editors, in the order of pages
  ActiveEditor - focused editor (on the active pages).
}

// Returns the index of tab icon depending on IsNew (document was created
// but never saved), FileFormat, Modified (document has unsaved changes)
function TForm3.GetIconIndex(IsNew: Boolean; FileFormat: TrvFileSaveFilter;
  Modified: Boolean): Integer;
begin
  Result := 0;
  if not IsNew then
    case FileFormat of
      ffeRVF:
        Result := 1;
      ffeRTF:
        Result := 2;
      else
        Result := 3;
    end;
  if Modified then
    inc(Result, 4);
end;
{------------------------------------------------------------------------------}
// When document is created, saved, loaded...
procedure TForm3.rvActionSave1DocumentFileChange(Sender: TObject;
  Editor: TCustomRichViewEdit; const FileName: TRVUnicodeString;
  FileFormat: TrvFileSaveFilter; IsNew: Boolean);
var s: String;
    Index: Integer;
begin
  s := ExtractFileName(FileName);

  rvActionPrint1.Title := s;
  rvActionQuickPrint1.Title := s;

  Index := GetIndexOfEditor(Editor);
  If Index >= 0 then begin
    PageControl1.Pages[Index].Caption := s;
    PageControl1.Pages[Index].ImageIndex := GetIconIndex(IsNew, FileFormat, False);
  end;
end;
{------------------------------------------------------------------------------}
// Prompt for saving...
procedure TForm3.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  while PageControl1.PageCount > 1 do
    if not CloseActiveEditor then
    begin
      CanClose := False;
      exit;
    end;
  CanClose := rvActionSave1.CanCloseDoc(ActiveEditor);
end;
{------------------------------------------------------------------------------}
procedure TForm3.mitExitClick(Sender: TObject);
begin
  Close;
end;
{------------------------------------------------------------------------------}
// Returns the index of TRichViewEdit in Editors[]
function TForm3.GetIndexOfEditor(rve: TCustomRichViewEdit): Integer;
var i: Integer;
begin
  for i:= 0 to High(Editors) do
    If Editors[i]=rve then
    begin
      Result := i;
      Exit;
    end;
  Result := -1;
end;
{------------------------------------------------------------------------------}
// finds the ruler for rve
function TForm3.GetRuler(rve: TCustomRichViewEdit): TRVRuler;
var i: Integer;
begin
  for i := 0 to ComponentCount - 1 do
    if (Components[i] is TRVRuler) and
       (TRVRuler(Components[i]).RichViewEdit=rve) then
    begin
      Result := TRVRuler(Components[i]);
      exit;
    end;
  Result := nil;
end;
{------------------------------------------------------------------------------}
// Returns information about document opened in TRichViewEdit
function TForm3.GetDocInfo(rve: TCustomRichViewEdit): TrvaDocumentInfo;
var DocIndex: Integer;
begin
  DocIndex := rvActionSave1.FindDoc(rve);
  if DocIndex>=0 then
    Result := TrvaDocumentInfo(rvActionSave1.Documents[DocIndex])
  else
    Result := nil;
end;
{------------------------------------------------------------------------------}
// Returns information about the active document (opened in ActiveEditor)
function TForm3.GetActiveDocInfo: TrvaDocumentInfo;
begin
  Result := GetDocInfo(ActiveEditor);
end;
{------------------------------------------------------------------------------}
// Adds a new page with editor, making it active
procedure TForm3.AddEditor;
var rve : TCustomRichViewEdit;
    ts: TTabSheet;
    ruler, ruler2: TRVRuler;
    Dummy: Boolean;
begin
  PageControl1Changing(nil, Dummy);

  SetLength(Editors, Length(Editors)+1);

  ts := TTabSheet.Create(PageControl1);
  ts.Visible := False;
  ts.PageControl := PageControl1;
  rve := TRichViewEdit.Create(Self);
  rve.Style := TRVStyle.Create(rve);
  rve.Style.TextStyles.Clear;
  rve.Style.TextStyles.Add;
  rve.Style.ParaStyles.Clear;
  rve.Style.ParaStyles.Add;
  rve.Parent := ts;

  // assigning events before creating ruler, because ruler will change
  // some of them
  (rve as TRichViewEdit).OnChange := RichViewEdit1Change;
  rve.OnJump := RichViewEdit1Jump;
  (rve as TRichViewEdit).OnKeyDown := RichViewEdit1KeyDown;
  (rve as TRichViewEdit).OnKeyPress := RichViewEdit1KeyPress;
  rve.OnReadHyperlink := RichViewEdit1ReadHyperlink;

  ruler := TRVRuler.Create(Self);
  ruler.RichViewEdit := rve;
  ruler.Parent := ts;
  ruler.Align := alTop;
  ruler2 := GetRuler(ActiveEditor);
  ruler.Height := ruler2.Height;
  ruler.SkinType := ruler2.SkinType;
  ruler.Flat := ruler2.Flat;
  ruler.MarginColor := ruler2.MarginColor;
  ruler.Options := ruler2.Options;
  ruler.UnitsDisplay := ruler2.UnitsDisplay;

  rve.Align := alClient;

  (rve as TRichViewEdit).PopupMenu := (ActiveEditor as TRichViewEdit).PopupMenu;
  rve.Options := ActiveEditor.Options;
  rve.RTFOptions := ActiveEditor.RTFOptions;
  rve.RTFReadProperties.Assign(ActiveEditor.RTFReadProperties);
  rve.RVFParaStylesReadMode := ActiveEditor.RVFParaStylesReadMode;
  rve.RVFTextStylesReadMode := ActiveEditor.RVFTextStylesReadMode;
  rve.UseStyleTemplates := ActiveEditor.UseStyleTemplates;

  if RVAControlPanel1.UnitsProgram <> rvstuPixels then
  begin
    rve.ConvertDocToDifferentUnits(RVAControlPanel1.UnitsProgram);
    rve.Style.ConvertToDifferentUnits(RVAControlPanel1.UnitsProgram);
  end;

  ActiveEditor := rve;
  Editors[High(Editors)] := rve;

  UpdateIcon(rve);
  ts.Visible := True;
  PageControl1.ActivePage := ts;
  PageControl1.OnChange(nil);

  mitClose.Enabled := PageControl1.PageCount>1;
end;
{------------------------------------------------------------------------------}
// File | New, overriding the action
procedure TForm3.rvActionNew1Execute(Sender: TObject);
begin
  // Instead of applying to the active editor,
  // we creating a new editor, making it active,
  AddEditor;
  // then execute rvActionNew for this new editor
  rvActionNew1.ExecuteTarget(ActiveEditor);
  UpdateIcon(ActiveEditor);
end;
{------------------------------------------------------------------------------}
// File | Open, overriding the action
procedure TForm3.rvActionOpen1Execute(Sender: TObject);
var DocInfo: TrvaDocumentInfo;
begin
  // Instead of applying to the active editor,
  // we creating a new editor, making it active,
  AddEditor;
  // then execute rvActionOpen for this new editor
  rvActionOpen1.ExecuteTarget(ActiveEditor);
  // Some assignments may set Modified flag, resetting
  UpdateIcon(ActiveEditor);
  // But may be the user pressed "Cancel" in the file opening dialog.
  // In this case, we closing the new tab.
  DocInfo := GetActiveDocInfo;
  if (DocInfo=nil) or not DocInfo.Defined then
    RemoveEditor(PageControl1.ActivePageIndex);
end;
{------------------------------------------------------------------------------}
// destroying PageControl1.Pages[Index] with all its contents
procedure TForm3.RemoveEditor(Index: Integer);
var i: Integer;
begin
  for i := Index to High(Editors)-1 do
    Editors[i] := Editors[i+1];
  SetLength(Editors, Length(Editors)-1);
  PageControl1.Pages[Index].Free;
  // When the page is destroyed, it destroys its controls: RichViewEdit and Ruler.
  // Since RichViewEdit = RVStyle.Owner, RVStyle is destroyed as well
  mitClose.Enabled := PageControl1.PageCount>1;
end;
{------------------------------------------------------------------------------}
// updating tab icon depending on Editor.Modified
procedure TForm3.UpdateIcon(Editor: TCustomRichViewEdit);
var EditIndex: Integer;
    DocInfo: TrvaDocumentInfo;
begin
  // Updating the tab icon to show a "modified" state
  DocInfo := GetDocInfo(Editor);
  if DocInfo=nil then
    exit;
  EditIndex := GetIndexOfEditor(DocInfo.rve);
  If EditIndex >= 0 then
    PageControl1.Pages[EditIndex].ImageIndex := GetIconIndex(not DocInfo.Defined,
      DocInfo.FileFormat, Editor.Modified);
end;
{------------------------------------------------------------------------------}
// Before changing the active page
procedure TForm3.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  // closing a note editing form, if it is open
  if (rvActionEditNote1.Form <> nil) and rvActionEditNote1.Form.Visible then
    rvActionEditNote1.Form.Close;
end;
// Occurs when another page becomes active
procedure TForm3.PageControl1Change(Sender: TObject);
var DocInfo: TrvaDocumentInfo;
begin
  if PageControl1.PageCount=0 then
    exit;
  ActiveEditor := Editors[PageControl1.ActivePageIndex];
  RVAControlPanel1.DefaultControl := ActiveEditor;
  DocInfo := GetActiveDocInfo;
  if DocInfo<>nil then
  begin
    rvActionPrint1.Title := ExtractFileName(DocInfo.FileName);
    rvActionQuickPrint1.Title := ExtractFileName(DocInfo.FileName);
  end;
  UpdateLinkedControls;
end;

{------------------------------------------------------------------------------}
// On editing
procedure TForm3.RichViewEdit1Change(Sender: TObject);
begin
  UpdateIcon(Sender as TCustomRichViewEdit);
end;
{------------------------------------------------------------------------------}
// Closing the active page
function TForm3.CloseActiveEditor: Boolean;
var Index: Integer;
begin
  Result := False;
  if PageControl1.PageCount>1 then
  begin
    Index := PageControl1.ActivePageIndex;
    if not rvActionSave1.CanCloseDoc(Editors[Index]) then
      exit;
    RemoveEditor(Index);
    if Index=PageControl1.PageCount then
      dec(Index);
    PageControl1.ActivePageIndex := Index;
    PageControl1Change(nil);
    Result := True;
  end;
end;
{------------------------------------------------------------------------------}
procedure TForm3.mitCloseClick(Sender: TObject);
begin
  CloseActiveEditor;
end;
{------------------------------------------------------------------------------}
// Changing measure units for all editors according to RVAControlPanel1.UnitsProgram
procedure TForm3.ChangeUnits;
var
  i: Integer;
begin
  for i := 0 to High(Editors) do
  begin
    Editors[i].ConvertDocToDifferentUnits(RVAControlPanel1.UnitsProgram);
    Editors[i].Style.ConvertToDifferentUnits(RVAControlPanel1.UnitsProgram);
    Editors[i].Change;
  end;
end;
{------------------------------------------------------------------------------}
// Changing ForceFieldHighlight for all editors
procedure TForm3.SetForceFieldHighlight(Value: Boolean);
var
  i: Integer;
begin
  for i := 0 to High(Editors) do
    Editors[i].ForceFieldHighlight := Value;
end;

end.
